package com.sf.day14._01_package.test;

/**
 * create By  fjl
 */
public class Test {

    public static void main(String[] args) {
        // 创建出来包装类
        // 从文档中看到包装类是提供了构造方法, 说明可以通过new 方法
//        Integer integer = new Integer(10);
//        if(integer!=null){
//            // 说明Integer 里面已经覆盖了Object当中toString()方法 打印integer int值
//            System.out.println(integer);
//            System.out.println("这是一个包装类型");
//        }
//
//        // 方式2  Integer.valueOf(10)
//        Integer integer1 = Integer.valueOf(11);
//        System.out.println(integer1);

        // 问题: 两者有什么区别?
        // Integer.valueOf()   在去操作时候有一个缓存池范围是 -128 127
        // 作用 如果第一个使用Integer.valueOf(10) 上缓存池中看是否有这个包装类,如果没有创建出来这个包装类
        //     第二次在去使用Integer.valueof(10)  上缓存池当中看是否有包装类, 如果有直接用这个包装类了

        //面试题,判断下面结果
        Integer integer = new Integer(10);
        Integer integer1 = new Integer(10);
        System.out.println(integer == integer1);   //false
        Integer integer2 = Integer.valueOf(10);
        Integer integer3 = Integer.valueOf(10);
        System.out.println(integer2==integer3);   //true
        System.out.println(integer1==integer3);   //false
        // 基本类型和包装类型转换
        // 作为了解, 因为以后我们都是直接使用包装类
        // 装箱: 基本类型转成包装类  拆箱: 包装类转成基本类型
        // jjdk5当中提供的自动装箱和拆箱其实是一个语法糖
        // 语法糖: 简化我们写代码 , 知道他本质磁层还是使用之前的方式
        // 没有语法糖: new  Integer 或者是 Integer.valueOf
        Integer i = 10;   //自动装箱  -> 装箱必须掌握
        int i1 = i;       //自动拆箱

    }
}
