package com.sf.day15._03_date;


import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Scanner;

/**
 * create By  fjl
 */
public class Test {
    public static void main(String[] args) throws ParseException {
//        method1();
//        method2();
//        method3();
//        method4();
//        method5();
        method6();
    }

    private static void method6() throws ParseException {
        /**
         * 用户输入日期: 2024-07-22 10:30:20
         * 用户输入加月 :1   输入加天: 7
         * 最终输出格式 2024.08.29 10:30:20
         */
        //1 创建出来一个Scaner   str 格式
        Scanner scanner = new Scanner(System.in);
        System.out.println("请输入日期:");
        String strDate = scanner.nextLine();
        //2 创建对象 接受输入月 和天
        System.out.println("请输入+月:");
        int mouth = scanner.nextInt();
        System.out.println("请输入+日:");
        int day = scanner.nextInt();
        //3 把str 日期格式转换成Date  SimpleDateFormate parse   date
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date = sdf.parse(strDate);
        //4 Calandar.getInstance();
        Calendar instance = Calendar.getInstance();
        //5 calendar.setTime(ddate);
        instance.setTime(date);
        //6 claendar.add()
        instance.add(Calendar.MONTH,mouth);
        instance.add(Calendar.DAY_OF_MONTH,day);
        //7 clalendar.getTime   date
        Date time = instance.getTime();
        //8 SimpleDateFormat   sdf.format(date);
        SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy.MM.dd HH:mm:ss");
        String str = sdf1.format(time);
        System.out.println(str);


    }

    private static void method5() {
        // 学习Calendar
        // 1 如何获取Calendar
        Calendar calendar = Calendar.getInstance();
        // 2 学习他的api   set  add  get
        // calender 对与日期进行运算操作 , 比如+  - 操作,你要操作哪一个日期对象告诉工具类
        // setTime: 告诉工具类我们要操作哪一个日期对象
        calendar.setTime(new Date());
        // get 方法可以帮我们去获取年月日时分秒的信息 , 但是这里他月特殊: 是从0开始
        System.out.println(calendar.get(Calendar.YEAR));
        System.out.println(calendar.get(Calendar.HOUR));
        System.out.println(calendar.get(Calendar.MONTH)+1);

        //add 可以对于我们日期进行运算操作
        // 要求讲 日增加一天
        calendar.add(Calendar.DAY_OF_MONTH,1);
        // getTime: 他可以把Calandar 内容转成date 对象
        Date date = calendar.getTime();
        System.out.println(date.toLocaleString());


    }

    private static void method4() throws ParseException {
        /**
         * 需求: 要求输入日期 2024-07-23  10:30:20
         * 要求打印  2024.07.23  10:30:20
         *
         * 关键点就是日期的格式如何转换
         * 1 scaner 输入内容是一个字符串
         * 2 把字符串转成一个date    sdf.format(str)
         * 3 创建一个新的simpleDateformat(yyyy.MM.dd HH:mm:ss)
         */
        Scanner scanner = new Scanner(System.in);
        System.out.println("请输入日期:");
        String d1 = scanner.nextLine();
        // 把他转换成date
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date = sdf.parse(d1);
        //创建一个sdf
        SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy.MM.ss HH:mm:ss");
        String str1 = sdf1.format(date);
        System.out.println(str1);
    }

    private static void method3() throws ParseException {
        // 要求在控制台输入两个日期 ,
        Scanner scanner = new Scanner(System.in);
        System.out.println("请输入第一个日期:");
        // 先输入第一个日期,
        // 在输入第二个日期
        // 日期格式 年-月-日 时-分-秒,
        String d1 = scanner.nextLine();
        System.out.println("请输入第二个日期:");
        String d2 = scanner.nextLine();
        // 在控制台打印日期1 和日期2 比较关系
        // 关键点日期的比较 可以使用时间戳进行比较 date.getTime();
        // 问题: 如何获取到输入内容的时间戳 有: 字符串  要: date   simpledateFormat.parse(str)
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date1 = sdf.parse(d1);
        Date date2 = sdf.parse(d2);
//
        if(date1.getTime()>date2.getTime()){
            System.out.println("日期1 大于日期2");
        }else{
            System.out.println("日期 小于日期2");
        }
    }



    private static void method2() throws ParseException {
        //1 如何创建出来这个类
        // 观察了SimpleDateFormat这个类有2个构造器, 我们是要用他有参构造器
        /**
         * 参数: 要们要打印的日期的格式
         * y: 年
         * M: 月
         * d: 日
         *
         * H: 小时
         * m: 分钟
         * s: 秒
         */
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy.MM.dd HH:mm:ss");
        //2 学习这个类当中常用方法
        /**
         * format : String format(Date date)
         * parse : Date parse(String source)
         */
        // 如何创建日期对象Date  new Date();
        String str = sdf.format(new Date());
        System.out.println(str);
        // 获取毫秒值
        // 把str 转换会日期对象
        Date date = sdf.parse(str);
        System.out.println(date);


    }

    private static void method1() {
        // 要求创建出来一个Date 日期类
        Date date = new Date();
        System.out.println(date);
        // 把日期转换成字符串 调用toString 方法
        System.out.println(date.toString());
        // 获取当前日期距离时间原点的毫秒值
        // 时间戳的应用常见: web领取当中会用他来解决一些图片缓存问题
        // 比如后面实现图形验证码功能: 在浏览器当中是有缓存功能, 第一次和第二次访问的结果是一样的浏览就不会去发送新的请求
        System.out.println(date.getTime());
        // 将我们日期格式转换成中国的格式
        System.out.println(date.toLocaleString());
        // 打印出来日期格式 20224.7.22 1:45.30  ,需求自定义打印出来日期的格式
    }
}
