package com.sf.day16._01_arrayList;

import com.sf.day16._01_arrayList.dt.Department;
import com.sf.day16._01_arrayList.dt.User;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * create By  fjl
 */
public class TestArrayList {


    public static void main(String[] args) {

//        method1();
//        method2();
        /**
         *  定义部门 id , name  ,sn
         *  要求在部门当中定义静态代码块初始化部门:
         *  要求创建3个部门对象new Department(1L,"test1","sn1") new Department(1L,"test2","sn2") ...
         *  把这三个对象放到ArrayList当中
         *
         *  要求在测试的时候
         *  method1():  输入删除的位置,删除对应的元素
         *  method2();  判断name是否等于test1, 如果等于test1把name 修改成test1111
         */
//        method3();
        method4();
    }

    private static void method4() {
        //1 获取集合
        ArrayList list = Department.list;
        //2 遍历集合拿到每一个集合元素
        for (int i = 0; i < list.size(); i++) {
            Department department = (Department) list.get(i);
            //3 判断集合当中元素Department 当中name 的值是否test1
            if("test1".equals(department.getName())){
                //4 如果值为test1 就把值修改成test1111
                department.setName("test111");
            }
        }
        System.out.println(list);
    }

    private static void method3() {
        //1 第一个Scaner对象
        Scanner scanner = new Scanner(System.in);
        //2 接受删除位置
        System.out.println("请输入删除位置从0开始:");
        int index = scanner.nextInt();
        //3 获取List集合
        ArrayList list = Department.list;
        //4 删除集合
        list.remove(index);
        System.out.println(list);
    }

    private static void method2() {
        // 往ArrayList 当中添加4个User 对象
        List list = new ArrayList();
        list.add(new User("zhangsan",10));
        list.add(new User("lisi",20));
        list.add(new User("wangwu",30));
        list.add(new User("zhaoliu",40));
        System.out.println(list);
    }

    private static void method1() {
        // 创建ArrayList
        List list = new ArrayList();
        /**
         *  往arrayList 当中添加三个元素   11, 22 ,33 ,22 ,44
         */
        // add
        list.add("123");
        list.add(22);
        list.add(33);
        list.add(22);
        list.add(44);
        // 有记录添加顺序, 允许重复
        System.out.println(list);
        // 查询  调用是get 方法,传入的索引
        /**
         *  思考问题: 为什么List 内部元素类型是Object 而不是某一个类型
         *  什么类型的数据都可以存
         */
        Object obj = list.get(0);
        /**
         * 获取数组当中的每一个元素
         * 进行遍历
         * size: list 集合的长度
         */
//        for (int i = 0; i < list.size(); i++) {
//            System.out.println(list.get(i));
//        }

        /**
         * 修改集合当中元素
         * 需求: 把索引为2位置元素修改成555
         * 返回值: 会把修改之前的内容返回
         */
        Object item = list.set(2, 555);
//        System.out.println(item);
//        for (int i = 0; i < list.size(); i++) {
//            System.out.println(list.get(i));
//        }

        /**
         * 删除结合当中元素
         * 在删除的时候如果在调用remove的时候你传入是一个基本类型值int 他就回认为你这是一个索引
         * 如果你要删除的元素内容就是一个int内容,我们应该是把他包装成一个Integer对象
         */
//        list.remove(0);
        //list.remove(Object obj)
        Integer it = Integer.valueOf(22);
        list.remove(it);
        for (int i = 0; i < list.size(); i++) {
            System.out.println(list.get(i));
        }

        // 注意 : 集合他是不支持存基本类型的, 他支持对象
    }
}
