package com.sf.day17._01_set;

import java.util.*;

/**
 * create By  fjl
 */
public class Test {

    public static void main(String[] args) {
       method3();

    }

    private static void method() {
        // 1 创建出来一个HashSet
        HashSet<String> set = new HashSet<>();
        // 往set集合添加元素
        set.add("123");
        set.add("sdss123");
        set.add("222");
        set.add("ccccc");
        set.add("456");
        // set集合当中不允许元素重复
        set.add("123");
        set.add("222");
        set.add("asdf");
        set.add("666");
        // 遍历
        for (String s : set) {
            System.out.println(s);
        }

        //删除元素 remove();
        // remove 删除单个元素 clear 是清空全部元素
//        set.remove("123");
        // 判断集合当中是否包含ccccc
        System.out.println(set.contains("ccccc"));

        set.clear();
        System.out.println(set);

        // 获取set集合当中元素, 这边没有办法想list那样直接调用get方法进行获取
    }

    public static void method1(){
        // 需求: 往集合当中添加四大名著 ,判断如果等于西游记就把西游记删除掉 使用set集合操作
        Set<String> set =new HashSet<>();
        set.add("西游记");
        set.add("红楼梦");
        set.add("水浒传");
        set.add("三国演义");

        for (String s : set) {
            if(s.equals("西游记")){
                set.remove("西游记");
            }
        }
        System.out.println(set);
    }

    public static void method2(){
        // 需求2: 现在有一个List集合  集合重复 有若干个元素  张三  李四  王五  张三  李四  赵六  王八....
        // 要求: 计算出来一共有多少个名字.
        List<String> list = Arrays.asList("张三", "李四", "王五", "张三", "李四", "赵六", "王八");
        Set<String> set = new HashSet<>();
        for (String s : list) {
            set.add(s);
        }
        System.out.println("一共有多少个名字:"+set.size());
    }

    public static void method3(){
        // 需求3: 在控制台输入字符串 "sttarbssce" ,  要求输出不重复的字母  starbsce  不要求顺序
        Scanner scanner = new Scanner(System.in);
        System.out.println("请输入内容:");
        String str = scanner.next();

        Set<Character> set = new HashSet<>();
        // 帮助我们把字符串变成字符数组
        char[] chars = str.toCharArray();
        for (int i = 0; i < chars.length; i++) {
            set.add(chars[i]);
        }

        // 遍历set集合
        StringBuilder sb = new StringBuilder();
        for (Character character : set) {
            sb.append(character);
        }
        System.out.println(sb.toString());
    }
}
