package com.sf.day17._01_set;

import com.sf.day17._01_set.dt.User;

import java.util.HashSet;
import java.util.Set;


/**
 * create By  fjl
 */
public class TestHashCode {

    public static void main(String[] args) {



        method1();
    }

    private static void method1() {
        // 需求: 创建出来4个User("will","10") User("fjl","20") User("wangwu","10) User("fjl",20);
        // 把这4 个 User全部放到Set集合当中
        User user = new User("will",10);
        User user1 = new User("fjl",20);
        User user2 = new User("wangwu",10);
        User user3 = new User("fjl",20);

        System.out.println(user1.hashCode());
        System.out.println(user3.hashCode());


        Set<User> set = new HashSet<>();
        set.add(user);
        set.add(user1);
        set.add(user2);
        set.add(user3);
        System.out.println(set);

        // 我希望user3 不存进去 , 但是他存进去了
        // 为什么存进去: 因为现在hashcode 是根据地址值进行计算的,都是不同就回存进去
        // 如果你想不存进去,我们要覆盖Object当中hashcode 方法和equals方法
    }

    // hashcode说明
    private static void method() {
        // 计算对象hashcode值

        /**
         * hashcode: 这个方法是Object当中提供方法,
         * 他会根据对象地址及通过运算计算出来一个int值
         * 这个int 值我们也叫做hash值
         */
        // 结论: 同一个对象多次hashcode 值是相同
        User user = new User("will",10);
        System.out.println("hashcode值:" + user.hashCode());
        System.out.println("hashcode值:" + user.hashCode());
        //      不同对象调用hashcode 值是不同
        User user1 = new User("will",10);
        System.out.println("hashCode值:"+ user1.hashCode());
    }
}
