package com.sf.day19._01_exception;

import com.sf.day19._01_exception.dt.User;
import com.sf.day19._01_exception.util.Result;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class Test {
    public static void main(String[] args) throws FileNotFoundException {
//        method1();
//        method2();
//        method3();
//        method9();
        // 需求: 要在控制台当中打印method4 代码 和 执行后面代码
//        method4(1,0);
//        System.out.println("执行后面代码");
    }

    private static void method9(int num ,int num1) {
//        User user = null;
//        user.eat();
        int ii = num/num1;
    }

    private static void method4(int num,int num1) throws ArithmeticException {
        try{
            method5(num,num1);
        }catch (ArithmeticException e){
            e.printStackTrace();
        }
        System.out.println("method4代码");
    }

    private static void method5(int num,int num1) throws ArithmeticException {
        method6(num,num1);
        System.out.println("method5代码");
    }
    private static void method6(int num, int num1) throws ArithmeticException {
        int i  = num/num1;
        System.out.println("method6代码");
    }
    private static int method3() {
        // 验证结论: 如果catch当中有return  , finally 也有return , 返回的时候谁的
        try{
            System.out.println("打开一个文件");
            //如果我们try 当中代码出现了问题, 那文件就无法正常关闭
            //解决: 使用finally, finally 当中代码最终执行, 不论代码是否出现异常
            // final 代码是一定会执行的
            int i =  1/0;
            return 0;
        }catch (Exception e){
            System.out.println("出现了异常信息");
            e.printStackTrace();
            return 1;
        }finally {
            // 通常情况下都是一些关闭资源的操作, 关闭文件, 关闭连接池
            System.out.println("关闭文件");
        }
    }

    /**
     * 需求: 在控制台当中输入两个数字: num和num1
     * 要求对num / num1
     * 如果代码没有问题 返回 {code:200,msg:"操作成功"}  对象
     * 如果代码有问题   返回 {code:500,msg: 是出现的异常信息} 对象
     */
    private static void method2() {
        // 1 创建出来一个Scaner 对象
        Scanner scanner = new Scanner(System.in);
        System.out.println("请输入除数: ");
        int num1 = scanner.nextInt();
        System.out.println("请输入被除数: ");
        int num2 = scanner.nextInt();

        try{
            double ret  = num1/num2;
            System.out.println(new Result(200, "操作成功"));
        }catch (ArithmeticException e){
            e.printStackTrace();
            System.out.println(new Result(500,e.getMessage()));
        }
    }

    private static void method1() {
        try{
            int abc = Integer.parseInt("abc");
            System.out.println("123123");
        }catch (NumberFormatException e) {
            // 异常对象里面有常用的三个方法 toString(),  getMessage() ,printStackTrace
//            System.out.println(e.toString());
//            System.out.println(e.getMessage());
            // 为了后续在出现bug的时候调试bug 信息我们通常情况下都会打印异常信息和异常位置
            e.printStackTrace();
//            System.out.println("字符串在格式化的时候出现了问题");
        }catch (Exception e){
            System.out.println("系统繁忙");
        }
    }


}
