package com.sf.day19._01_exception.able.impl;

import com.sf.day19._01_exception.able.ILoginAble;
import com.sf.day19._01_exception.ex.LoginException;
import com.sf.day19._01_exception.vo.LoginVO;

import java.io.File;

public class LoginAbleImpl implements ILoginAble {

    @Override
    public void login(LoginVO vo) throws IllegalAccessException,NullPointerException {
        // 要求2 如果username 或者是password 为空抛出NullPointException
        // 要求3 如果验证码为空 抛出一个空指针异常
        if(vo.getUsername() == null || vo.getPassword() == null || vo.getCode() == null){
            throw new LoginException("账号或者密码或者是验证码不能为空");
        }
        // 要求4 那用户输入验证码和loginvo 的验证码abce 比较如果不正确throw IllegalArgumentException
        if(!LoginVO.vo.getCode().equalsIgnoreCase(vo.getCode())){
            throw new LoginException("验证码错误");
        }
        // 要求4 那用户输入username 和"admin" 密码
        // 和初始化当中admin 密码也是和初始化对象密码比较账号密码正确在控制台当中输入登录成功,否则登录失败
        String username = LoginVO.vo.getUsername();   //admin
        String password = LoginVO.vo.getPassword();   //123
        if(username.equalsIgnoreCase(vo.getUsername()) && password.equalsIgnoreCase(vo.getPassword())){
            System.out.println("登录成功");
        }else{
//            System.out.println("登录失败");
            throw new LoginException("账号或者是密码错误");
        }
        // 要求5 同时要在login 方法上提醒调用者方法可能出现的异常
    }
}
