package com.sf.day19._02_file._01_file_api;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;

public class TestFileApi {

    public static void main(String[] args) throws IOException {
//        method1();
//        method2();
        method3();
    }

    // 需求2:
    // 在d:\\aa 有 4文件 a.txt  b.txt  acc.txt  d.txt要求吧名字当中有a 文件删除掉
    private static void method3() {
        //1 获取d:\\aa 目录所有内容  listFiles();
        File file = new File("d:\\aa");
        File[] files = file.listFiles();
        //2 遍历数组拿到每一个File
        for (File file1 : files) {
            //3 获取file 路径
            //file.getName  如果这个file 是一个文件获取就是文件的名字
            //如果一个路径获取就是他的绝对路径
            String path = file1.getName();
            //4 判断路径当中是否包含a
            if(path.contains("a")){
                file1.delete();
            }
        }
    }
    // 需求1
    // 要求控制台当中输入 路径信息 如果输入 abc  要就在D:\\abc\\abc
    //                          如果输入的内容已经存在了就提醒用户已存在请修改路径
    //                          如果输入的a.txt  那就在D:\\abc\\a.txt


    // 需求3:  有D:\\abc   这个目录下面有 a目录 ,b.txt ,c.txt   ,a目录当中还有cc.txt
    //  要打印出abc 目录当中所有的路径保存子目录的路径
    private static void method2() throws IOException {
        //1 在控制台当中输入路径
        Scanner scanner = new Scanner(System.in);
        System.out.println("请输入路径");
        //2 创建File 对象
        String path = scanner.next();
        String filePath = "D:\\abc\\" + path;
//        System.out.println(filePath);
        File file = new File(filePath);
//        System.out.println(file.getAbsolutePath());
        //3 调用file.exists() 判断是否存在
        if(file.exists()){
            System.out.println("文件已经存在请修改路径");
            return;
        }

        String absolutePath = file.getAbsolutePath();
        if(!absolutePath.contains(".")){
            file.mkdirs();
        }{
            file.createNewFile();
        }

        //4 判断他是目录还是文件, 如果是目录就创建目录u,如果是文件就创建文件
        // 问题: file.isDirectory 只能够去判断磁盘当中存在的目录
        // 思路: 一般文件是有后缀 .java .txt  .html
        // isDirectory 如果在磁盘当中不论存不存在都能判断
        // 但是发现他只能够判断磁盘当中存在的目录, 不存在他无法判断
        /**
         * 解决思路: 既然他无法帮我们去判断我们输入的内容是一个目录还是一个文件
         * 那我就要自己想办法去判断输入的内容是目录还是文件
         * 我知道 目录是没有后缀.txt   文件是有后缀
         *
         * 想到了api: indexOf  contains 都可以判断字符串当中是否包含某一个内容,
         * 判断你的字符串是否包含. ,如果包含. 表示他是一个文件, 如果不包含表示他是一个目录
         */

    }


    private static void method1() throws IOException {
        // 如何创建一个File的类 , 这个类有没有提供无参数构造器
        File file = new File("D:\\abc\\a.txt");
        // 默认他打印就是文件的路径
        System.out.println(file);
        // 创建一个文件 createNewFile();
        // 在abc 目录当中伴我们创建一个a.txt文件
//        file.createNewFile();
        // 获取getName 返回值也是路径
        String name = file.getName();
        System.out.println(file);
        // 判断当前路径是否是一个目录
        System.out.println(file.isDirectory());
        // 判断当前路径是否是一个文件
        System.out.println(file.isFile());
        // 判断当前路径文件获目录是否存在
        System.out.println(file.exists());
        // 创建目录的操作 mkdir
        // D:\abc\caa  mkdir 只能够创建一层
        File file1 = new File("D:\\abc\\caa\\acc");
//        file1.mkdir();
        // mkdirs 创建层级目录
        file1.mkdirs();
        // 获取文件绝对路径
        // 绝对路径                      相对路径
        // 绝对路径就是这个文件的完整路径
        File file2 = new File("TestFileApi.java");
        String absolutePath = file2.getAbsolutePath();
        System.out.println(absolutePath);

        // 列举目录当中所有内容api
        File file3 = new File("D:\\abc");
        File[] files = file3.listFiles();
        System.out.println(Arrays.toString(files));

        //file 当中提供了delete 方法可以帮我们删除文件
        File file4 = new File("D:\\abc\\a.txt");
        file4.delete();


    }
}
