package com.sf.day21._04_properties;

import org.junit.Test;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

public class MyTest
{


    /**
     * 需求: 现在有一个User类 User类当中有两字段username 一个password
     * 要求吧配置文件db.properties 当中username值  和password 的值123 设置对象的字段中
     *
     */
    @Test
    public void test() throws IOException {
        // 这个需求就设计到读取配置文件内容
        /**
         * Properties 常用类
         * 提供无参数构造器
         * properties.load(inputStream 输入流);
         * properties.getProperty(key) 获取配置文件当中内容 比如getProperty(username) root
         */
        //加载properties 文件
        // 以后在实际开发当中不会采用new FileInputStream 方式呢？
        // 原因： 是因为这里的路径写死了， 而且有盘符d:\\  c:\\  但是在Linux 当中和Mac 是没有盘符的概念的
        // 以后我们代码要在Linux 系统上运行， 如果这样在你的电脑可以运行， 但是一旦运行在Linux 当中就运行不了
        FileInputStream fileInputStream = new FileInputStream(new File("D:\\ideaproject\\VIP35\\src\\main\\resources\\db.properties"));
        Properties properties  = new Properties();
        properties.load(fileInputStream);

        // 最红把信息存到User 中
        String username = properties.getProperty("username");
        String password = properties.getProperty("password");
        System.out.println(username +"----" + password);
    }
}
