package com.sf.day28.dao;

import com.sf.day28.domain.User;

import java.util.List;

public interface IUserDAO {
    /**
     * 新增
     */
    void insert(User user);

    /**
     * 编辑
     */
    void update(User user);

    /**
     * 删除
     */
    void delete(Long id);

    /**
     * 查询单个
     */

    User get(Long id);

    /**
     * 查询所有
     */
    List<User> list();
}
