package com.sf.day31._01_tcp;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Scanner;

public class Server {
    // 思考： 现在我们服务端接受一次请求就结束了，我想要效果是可以一直接受请求
    // 改造1： 服务端代码要一直运行，可以接受多个请求的信息
    public static void main(String[] args) throws IOException {
//        1:创建一个服务端对象(ServerSocket)

        ServerSocket serverSocket = new ServerSocket(10086);
//        2:侦听客户端的连接,获取和客户端通信的Socket对象
        while (true){
            Socket accept = serverSocket.accept();
//        3:从Socket获取输入流,接收服务器发送的数据
            InputStream inputStream = accept.getInputStream();
            byte[] buffer = new byte[1024];
            int len = -1;
            while ((len = inputStream.read(buffer))!=-1){
                System.out.println(new String(buffer,0,len));
            }
//        4:调用Socket对象对象shutdownInput方法通知客户端数据接收完毕
            accept.shutdownInput();
//        5:从Socket中拿到输出流往客户端发送数据
            Scanner scanner = new Scanner(System.in);
            String msg = scanner.next();
            OutputStream outputStream = accept.getOutputStream();
//        6:调用Socket对象对象shutdownOutput方法通知客户端数据发送完毕
            outputStream.write(("迪丽热巴："+msg).getBytes("UTF-8"));
//        7:关闭Socket对象
            accept.close();
            inputStream.close();
            outputStream.close();
        }

    }
}
