package com.sf.day07_2;
import java.util.Arrays;

/**
 *Arrays工具类的使用
 */
public class Test {
    @org.junit.Test
    public void t1(){

        //toString
        int[] arr = {2,3,4,5,6,7};
        System.out.println(arr);
        String arrStr = Arrays.toString(arr);
        System.out.println(arrStr);
    }

    @org.junit.Test
    public void t2(){
        int[] arr = {3,2,5,1,7,9,4};
//        Arrays.sort(arr);
        Arrays.sort(arr,1,5);
        System.out.println(Arrays.toString(arr));
    }


    @org.junit.Test
    public void t3(){
        int[] arr = {1,2,3,4,5,6,7,8,9};
        int i = Arrays.binarySearch(arr, 10);
        System.out.println(i);
    }


    @org.junit.Test
    public void t4(){
        int[] arr =  {1,2,3,4,5,6,7,8,9};
//        int[] ints = Arrays.copyOf(arr, 8);
//        System.out.println(Arrays.toString(ints));
        int[] ints = Arrays.copyOfRange(arr, 1, 6);
        System.out.println(Arrays.toString(ints));
        boolean equals = Arrays.equals(arr, ints);
        System.out.println(equals);
        Arrays.fill(ints,1,4,99);
        System.out.println(Arrays.toString(ints));
    }

    /**
     * 方法
     * 语法结构:
     * 权限修饰符  [其他修饰符]  返回值类型(有/无) 方法名 (参数列表(Object...args)) [throws  异常列表(多个)]{  代码体}
     * 方法的定义  有参无参 (参数  形参和实参)  有返回值无返回值
     * 静态方法和实例方法
     * 方法的调用  (在同一个类中   在不同类中)
     * 重载方法  : 方法名相同   参数列表不同   (和权限修饰符以及其他修饰符 以及返回值无关)
     */
    @org.junit.Test
    public void t5(){
        //调用静态方法
        staticEat();
        //调用实例方法  (X)
        eat("admin");
    }

    public String eat(String name){
        return "admin";
    }

    public static void staticEat(){

    }

    public static void main(String[] args) {
        //调用静态方法
        staticEat();
        //调用实例方法  (X)
//        eat();
    }

//  重载方法
    public void run(){

    }
    public void run(String name){

    }

    //  错误的
//    public static void run(String name){
//
//    }


    /**
     *  设计一个方法可以返回  A-Z  之间的随机字符。
     *  第一种  创建数组  随机找下标index
     *  第二种方式   int  -- char
     */

    public char getChar(int start , int end){
        return (char) (Math.random()*(end - start+1)+start);
    }

    @org.junit.Test
    public void t7(){
        for (int i = 0; i < 10; i++) {
            char aChar = getChar(65, 90);
            System.out.println(aChar);
        }
    }


}
