package com.sf.day18._01_treeset;

import com.sf.day18._01_treeset.dt.Student;

import java.util.Comparator;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

public class TestTreeSet {

    public static void main(String[] args) {



        method2();

    }

    private static void method2() {
        TreeMap<Integer, Student> treeMap = new TreeMap<>(new Comparator<Integer>() {
            @Override
            public int compare(Integer o1, Integer o2) {
                return o2 - o1;
            }
        });

        // 1 要求往map当中存数据 key(Integer)-value(Student(id,name,age)) 往里面插入3个key-value
        treeMap.put(1,new Student(1,"zhangsan",10));
        treeMap.put(3,new Student(3,"wangwu",30));
        treeMap.put(2,new Student(2,"lisi",20));
        // 2 要求要按照id 进行降序
        // 最终打印出来id 最大的要前面遍历出来每一个key-value 元素
        for (Map.Entry<Integer, Student> entry : treeMap.entrySet()) {
            // 3 在遍历的过程中判断如果name名字是张三,那就给他的年龄+10岁
            Student s = entry.getValue();
            if("zhangsan".equals(s.getName())){
                // 就吧年龄加10岁
                s.setAge(s.getAge() +10);
                // 吧修改完以后Student 重新放到map当中
                treeMap.put(entry.getKey(),s);
            }
            System.out.println(entry.getKey() +"-"+entry.getValue());
        }

    }

    public static void method1(){
        // 测试TreeApi
        // 1 创建出来一个TreeSet，提供了无参数构造器
        Map<String,Object> map = new TreeMap<>();
        map.put("a","123");
        map.put("c","223");
        map.put("b","323");
        map.put("e","44");
        System.out.println(map);
        // 如何便利map 拿到map的所有的key -value
        /**
         * 遍历map 拿到每一个key 和value
         *
         * 方式1： 拿到map当中所有的key ，可以根据key 上map 当中获取他所有的value
         * 要求在控制台当中  key-value
         */
        Set<String> set = map.keySet();
        for (String key : set) {
            System.out.println("key:"+ key + " - value:" + map.get(key));
        }

        /**
         * 方式2： map.entrySet  获取一个键值对集合
         * 遍历键值对集合 ， 里面元素提供获取key 和获取value 方法
         * key键- value值  (键值对) 多个这中数据
         */
        Set<Map.Entry<String, Object>> set1 = map.entrySet();
//        Map.Entry<String, Object>  键值对
        for (Map.Entry<String, Object> entry : set1) {
            System.out.println(entry);
            // 获取map 当中key 和map 当中value
            System.out.println("key: "+ entry.getKey() + "-value:"+ entry.getValue());
        }
    }
}
