package com.sf.day22._01_properties.service.impl;

import com.sf.day22._01_properties.data.Data;
import com.sf.day22._01_properties.dt.User;
import com.sf.day22._01_properties.ex.LoginException;
import com.sf.day22._01_properties.service.ILoginService;

import java.util.Map;

public class LoginServiceImpl implements ILoginService {

    /**
     *   2 在接口实现类当中判断配置文件当中账号和密码 与 map 当中账号密码做对比
     *   3 如果成功 在数据{code:200,msg："操作成功"}；
     *   4 如果失败 {code:500,msg: "登录失败"}
     *   5 扩展：登录成功或者登录失败 往d:\\login.txt 当中添加 姓名 +"--" +时间 + 成功/失败
     *   注意如果账号密码不正确要求在方法方法中抛出LoginException("登录失败")
     *
     *   username和password 就是配置文件的账号和密码
     *   zhangsan  123
     *   lisi      566
     *   wangwu    666
     *
     *   配置文件
     *   lisi123     566
     */
    @Override
    public void login(String username, String password) {
        Map<Long, User> map = Data.map;
        // 如何那传入的账号和密码  与map 当中账号密码做对比
        // 可以遍历map 拿到每一个账号和密码 ， 进行一一对比即可
        //lisi     lisi  666
        //zhangsan zhangsan 123
        boolean flag = false;
        for (Map.Entry<Long, User> entry : map.entrySet()) {
            /**
             * zhangsan  123
             * lisi      566
             * wangwu    666
             */
            User user = entry.getValue();
            if(user.getUsername().equals(username)&& user.getPassword().equals(password)){
                flag = true;
            }
        }
        if(!flag){
            // 插入失败日志  username
            throw new LoginException("账号密码错误");
        }
        // 插入成功日志
    }
}
