package com.sf.day27._02_dao.dao;

import java.math.BigDecimal;

public interface AccountDAO {
    /**
     * 查询账户余额是否足够
     * id  userid
     * amount 你要消费的金额
     */
    boolean checkAmount(Long id , BigDecimal amount);

    /**
     * 减少账户余额
     */
    void decrAmount(Long userId, BigDecimal amount);
}
