package com.sf.day27._02_dao.dao.impl;

import com.sf.day27._02_dao.dao.AccountDAO;

import java.math.BigDecimal;
import java.sql.*;

public class AccountDAOImpl implements AccountDAO {

    @Override
    public boolean checkAmount(Long id, BigDecimal amount) {
        Connection connection = null;
        PreparedStatement preparedStatement =null;
        ResultSet resultSet = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            // 获取连接对象
            connection = DriverManager.getConnection("jdbc:mysql:///jdbcdemo1", "root", "admin");

            // 创建要执行语句
            String sql = "select * from t_account where id =? and amount> ?";
             preparedStatement = connection.prepareStatement(sql);
            // 设置sql 的参数
            preparedStatement.setLong(1,id);
            preparedStatement.setBigDecimal(2,amount);
            resultSet = preparedStatement.executeQuery();
            if(resultSet.next()){
                return true;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            try {
                if(connection!=null){
                    connection.close();
                }

            } catch (SQLException e) {
                e.printStackTrace();
            }
            try {
                if(preparedStatement!=null){
                    preparedStatement.close();
                }

            } catch (SQLException e) {
                e.printStackTrace();
            }
            ;
            try {
                if(resultSet!=null){
                    resultSet.close();
                }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
        return false;
    }

    @Override
    public void decrAmount(Long userId, BigDecimal amount) {
        Connection connection = null;
        PreparedStatement preparedStatement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            // 获取连接对象
            connection = DriverManager.getConnection("jdbc:mysql:///jdbcdemo1", "root", "admin");

            // 创建要执行语句
            String sql = "update t_account set amount = amount-? where id = ?";
            preparedStatement = connection.prepareStatement(sql);
            // 设置sql 的参数
            preparedStatement.setBigDecimal(1,amount);
            preparedStatement.setLong(2,userId);

            preparedStatement.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            try {
                if(connection!=null){
                    connection.close();
                }

            } catch (SQLException e) {
                e.printStackTrace();
            }
            ;try {
                if(preparedStatement!=null){
                    preparedStatement.close();
                }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }
}
