package com.sf.day27._02_dao.dao.impl;

import com.sf.day27._01_jdbc_concat.domain.Order;
import com.sf.day27._02_dao.dao.OrderDAO;
import com.sf.day28.util.JDBCUtil;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class OrderDAOImpl implements OrderDAO {

    @Override
    public void updateOrderStatus(Long userId) {
        Connection connection = null;
        PreparedStatement preparedStatement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            // 获取连接对象
            connection = DriverManager.getConnection("jdbc:mysql:///jdbcdemo1", "root", "admin");

            // 创建要执行语句
            String sql = "update t_order set status = 1 where id = ?";
            preparedStatement = connection.prepareStatement(sql);
            // 设置sql 的参数
            preparedStatement.setLong(1,userId);
            preparedStatement.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            try {
                if(connection!=null){
                    connection.close();
                }

            } catch (SQLException e) {
                e.printStackTrace();
            }
            ;try {
                if(preparedStatement!=null){
                    preparedStatement.close();
                }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public void insert(Order order) {
        Connection connection = JDBCUtil.getConnection();
        PreparedStatement preparedStatement =null;
        String sql = "insert into t_order (productName,price,user_id) values(?,?,?)";
        try {
             preparedStatement = connection.prepareStatement(sql);
            preparedStatement.setString(1,order.getProductName());
            preparedStatement.setBigDecimal(2,order.getPrice());
            preparedStatement.setLong(3,order.getUser_id());
            preparedStatement.executeUpdate();
        } catch (SQLException e) {
            e.printStackTrace();
        }finally {
            JDBCUtil.close(connection,null,preparedStatement);
        }
    }
}
