package com.sf.day31._02_chat;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.Scanner;

public class Client {

    public static void main(String[] args) throws IOException {
        while (true){
            Scanner scanner = new Scanner(System.in);
            String msg = scanner.next();
//        1 创建一个连接某个服务Socke对象
            Socket socket = new Socket("localhost",10086);
//        2 从Socket中拿到输出流服务端发送数据
            OutputStream outputStream = socket.getOutputStream();
            outputStream.write(("范佳龙："+msg).getBytes("UTF-8"));
//        3 调用Socket对象shutdownOutput 方法通知服务端数据发送完毕
            socket.shutdownOutput();
//        4 从Socket中拿到输入流获取服务端回馈的数据
            InputStream inputStream = socket.getInputStream();
            byte[] buffer = new byte[1024];
            int len = -1;
            while ((len = inputStream.read(buffer))!=-1){
                System.out.println(new String(buffer,0,len));
            }
//        5 调用Socket对象shutdownInput方法通知服务端数据收集完毕
            socket.shutdownInput();
//        6 关闭Socket对象
            socket.close();
        }
    }
}
