package com.sf.day31._02_chat;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Scanner;

public class Server {

    public static void main(String[] args) throws IOException {
//        1:创建一个服务端对象(ServerSocket)
        ServerSocket serverSocket = new ServerSocket(10086);
//        2:侦听客户端的连接,获取和客户端通信的Socket对象
        while (true){
            Socket socket = serverSocket.accept();
//        3:从Socket获取输入流,接收服务器发送的数据
            InputStream inputStream = socket.getInputStream();
            byte[] buffer = new byte[1024];
            int len = -1;
            while ((len = inputStream.read(buffer))!=-1){
                System.out.println(new String(buffer,0,len));
            }
//        4:调用Socket对象对象shutdownInput方法通知客户端数据接收完毕
//        5:从Socket中拿到输出流往客户端发送数据
            Scanner scanner = new Scanner(System.in);
            String msg = scanner.next();
            OutputStream outputStream = socket.getOutputStream();
            outputStream.write(("迪丽热巴："+msg ).getBytes("UTF-8"));
//        3 调用Socket对象shutdownOutput 方法通知服务端数据发送完毕
            socket.shutdownOutput();
//        6:调用Socket对象对象shutdownOutput方法通知客户端数据发送完毕
//        7:关闭Socket对象
            socket.close();
        }

    }
}
